import uuid

from django.contrib.auth import get_user_model
from django.db import models


class Video(models.Model):
    """
    Represent a video.
    """

    id = models.UUIDField(primary_key=True, default=uuid.uuid4)

    name = models.CharField(max_length=128)
    author = models.ForeignKey(to=get_user_model(), on_delete=models.CASCADE, related_name="videos")
    content = models.FileField(upload_to=f"videos/")
